// QuickClock.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <shellapi.h>
#include "smlcrt.cpp"
#include <math.h>

#define MINUTE 1
#define SECOND 2
#define HOUR 3
#define WM_TRAYICONCLICKED WM_USER+1
#define MAX_LOADSTRING 100
#define PIE 3.1415926535897932384626433832795
#define TIMER_ID 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text
HWND mainWnd = NULL;
HICON hFrame = NULL;
bool bShowMilliseconds = true;
// function declatations
void TrayIcon(UINT state,HICON resIcon,char *message);
HICON CombineIcons(HICON bottomIcon,const int &xBottomStart,const int &yBottomStart,HICON topIcon,const int &xTopStart,const int &yTopStart,const SIZE &combinedDimentions);
POINT CalculateClockHandPos(POINT point, int Pos,int Num,int radius);
void Timer(void);
char *CreateTimeString(char *buffer,const SYSTEMTIME &sysTime);
bool DrawIconHand(HDC destDC,HDC destDCMask,int nValue,POINT ptCenterPoint,int nTotal,int nLength,COLORREF crColor);
HICON CreateClockIcon(unsigned short nHour,unsigned short nMinute, unsigned short nSecond, unsigned short nMillisecond);
void MakeIcon(HICON hClockIcon,SYSTEMTIME *stCurrentTime);
const char * GetCommandLineString(const char *pSourceString,char *pTempBuffer);


// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int,int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	int nTimerInterval = 0;
	if(lpCmdLine[0] != '\0')
	{// begin move to the first switch
		for(int i = 0;lpCmdLine[i] != '/';i++)
			if(lpCmdLine[i] == '\0')	// invalid command line
				break;
		if(lpCmdLine[i] == '/')
		{// begin parse command line
			// move to the switch option
			i++;
			// create temporay character
			char option = lpCmdLine[i];
			// create input buffers
			char pString[MAX_PATH] = {NULL};
			// create new string pointer
			const char *pNextString = NULL;
			// make lowercase
			CharLower(&option);
			// parse options
			switch(option)
			{// begin options switch
				case 'm':	// backup player
					GetCommandLineString(&lpCmdLine[i+1],pString);
					nTimerInterval = Atoi(pString);
					break;
				default:	// invalid switch
					break;
			}// end options switch
		}// end parse command line
	}// end move to the first switch

	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	lstrcpy(szTitle, "QUICKCLOCK");
	lstrcpy(szWindowClass, "QUICKCLOCK");
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow,nTimerInterval)) 
	{
		return FALSE;
	}

	hAccelTable = NULL;//LoadAccelerators(hInstance, (LPCTSTR)IDC_QUICKCLOCK);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_QUICKCLOCK);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_QUICKCLOCK;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_QUICKCLOCK);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow, int nTimerInterval)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle,WS_VISIBLE,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }
	mainWnd =  hWnd;

	ShowWindow(hWnd, SW_HIDE);
	if(nTimerInterval == 0 || nTimerInterval > 500)
	{
		bShowMilliseconds = false;
		nTimerInterval = 1000;
	}
	SetTimer(mainWnd,TIMER_ID,nTimerInterval,NULL);
	hFrame = (HICON)LoadImage(hInst,MAKEINTRESOURCE(IDI_CLOCKBASE),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
//	HICON icon = (HICON)LoadImage(hInst,MAKEINTRESOURCE(IDI_QUICKCLOCK),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	TrayIcon(NIM_ADD,hFrame,"");
//	DestroyIcon(icon);
   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	wmId    = LOWORD(wParam); 
	wmEvent = HIWORD(wParam); 

	switch (message) 
	{
		case WM_TIMER:
			if(wmId == TIMER_ID)
				Timer();
			break;
		case WM_COMMAND:
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_TRAYICONCLICKED:
		switch(lParam)
		{// begin tray event
		case WM_RBUTTONDOWN:
			POINT pt;
			GetCursorPos(&pt);
			SetForegroundWindow(hWnd);
			HMENU trayMenu;
			trayMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDC_QUICKCLOCK));
			trayMenu = GetSubMenu(trayMenu,0);
			TrackPopupMenu(trayMenu,TPM_RIGHTALIGN|TPM_BOTTOMALIGN|TPM_RIGHTBUTTON,pt.x,pt.y,0,hWnd,NULL);
			break;
		}// end tray event
		break;
		case WM_DESTROY:
			KillTimer(mainWnd,TIMER_ID);
			DestroyIcon(hFrame);
			TrayIcon(NIM_DELETE,NULL,"");
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			else
			{
				switch(LOWORD(wParam))
				{
					case IDC_WEBSITE:
						ShellExecute(NULL, (char*)("open"), "http://am-productions.yi.org/", NULL,NULL, SW_SHOW);	
						break;
					case IDC_EMAIL:
						ShellExecute(NULL, (char*)("open"), "mailto:amistry@am-productions.yi.org", NULL,NULL, 0);
						break;
					case IDC_REGISTER:
						ShellExecute(NULL, (char*)("open"), "http://am-productions.yi.org/reg.php", NULL,NULL, 0);
						break;
				}
			}
			break;
	}
    return FALSE;
}

void TrayIcon(UINT state,HICON resIcon,char *message)
{// begin TrayIcon
	NOTIFYICONDATA trayIconData;
	trayIconData.cbSize = sizeof(NOTIFYICONDATA);
	trayIconData.hIcon = resIcon;
	trayIconData.hWnd = mainWnd;
	trayIconData.uCallbackMessage = WM_TRAYICONCLICKED;
	trayIconData.uFlags = NIF_TIP|NIF_MESSAGE|NIF_ICON;
	trayIconData.uID = 12;
	lstrcpy(trayIconData.szTip,message);
	Shell_NotifyIcon(state, &trayIconData);

}// end TrayIcon

HICON CombineIcons(HICON bottomIcon,const int &xBottomStart,const int &yBottomStart,HICON topIcon,const int &xTopStart,const int &yTopStart,const SIZE &combinedDimentions)
{// begin CombineIcons

	ICONINFO newIcon;
	newIcon.fIcon = true;
	HDC screenDC = ::GetDC(NULL);
	HDC iconDC = CreateCompatibleDC(screenDC);
	HDC maskDC = CreateCompatibleDC(screenDC);
	newIcon.hbmColor = CreateCompatibleBitmap(screenDC,combinedDimentions.cx,combinedDimentions.cy);
	newIcon.hbmMask = CreateCompatibleBitmap(maskDC,combinedDimentions.cx,combinedDimentions.cy);
	HGDIOBJ oldIconDC = ::SelectObject(iconDC,newIcon.hbmColor);
	HGDIOBJ oldMaskDC = ::SelectObject(maskDC,newIcon.hbmMask);
	BitBlt(iconDC,0,0,16,16,NULL,0,0,BLACKNESS);
	BitBlt(maskDC,0,0,16,16,NULL,0,0,WHITENESS);

	DrawIconEx(iconDC,xBottomStart,yBottomStart,bottomIcon,16,16,NULL,NULL,DI_NORMAL);
	DrawIconEx(iconDC,xTopStart,yTopStart,topIcon,16,16,NULL,NULL,DI_NORMAL);
	DrawIconEx(maskDC,xBottomStart,yBottomStart,bottomIcon,16,16,NULL,NULL,DI_NORMAL|DI_MASK);
	DrawIconEx(maskDC,xTopStart,yTopStart,topIcon,16,16,NULL,NULL,DI_NORMAL|DI_MASK);
	::SelectObject(iconDC,oldIconDC);
	::SelectObject(maskDC,oldMaskDC);
	HICON newFileIcon = CreateIconIndirect(&newIcon);
	DeleteObject(newIcon.hbmColor);
	DeleteObject(newIcon.hbmMask);
	DeleteObject(oldIconDC);
	DeleteObject(oldMaskDC);
	DeleteDC(maskDC);
	DeleteDC(iconDC);
	::ReleaseDC(NULL,screenDC);
	return newFileIcon;

}// end CombineIcons

POINT CalculateClockHandPos(POINT point, int Pos,int Num,int Radius)
// precondition: point is a defined POINT of where the center of the area is drawn
//				 Pos is the linear position of item to be calculated.
{

	int ItemHeight = 1;
	int ItemWidth = 1;
	POINT pt = {NULL};

	// adjust the pos so that 0 is at 12 o'clock
	Pos -= Num/4;

	pt.x = Radius*cos((2*PIE*Pos)/Num)+point.x-(ItemHeight/2);		// 99.9906055343044551579175019907702 Radius = 100
	pt.y = Radius*sin((2*PIE*Pos)/Num)+point.y-(ItemWidth/2);		// 1.37069503651368915565336356870794

	return pt;
}
char *CreateTimeString(char *buffer,const SYSTEMTIME &sysTime)
{// begin CreateTimeString
	int hour = 0;
	char cHourTwoDigit[2] = {NULL};
	char cMinuteTwoDigit[2] = {NULL};
	char cSecondTwoDigit[2] = {NULL};
	if(sysTime.wHour == 0)
		hour = 12;
	else if(sysTime.wHour > 12)
		hour = sysTime.wHour-12;
	else
		hour = sysTime.wHour;
	if(hour < 10)
		cHourTwoDigit[0] = '0';
	if(sysTime.wMinute < 10)
		cMinuteTwoDigit[0] = '0';
	if(sysTime.wSecond < 10)
		cSecondTwoDigit[0] = '0';
	wsprintf(buffer,"%hu/%hu/%hu %hs%hu:%hs%hu:%hs%hu",sysTime.wDay,sysTime.wMonth,sysTime.wYear,cHourTwoDigit,hour,cMinuteTwoDigit,sysTime.wMinute,cSecondTwoDigit,sysTime.wSecond);
	if(sysTime.wHour > 11)
		lstrcat(buffer," PM");
	else
		lstrcat(buffer," AM");

	return buffer;
}// end CreateTimeString
void Timer(void)
{// begin Timer
	SYSTEMTIME currentTime = {NULL};
	GetLocalTime(&currentTime);
	int nTempHour = currentTime.wHour;
	
	if(currentTime.wHour > 11)
		nTempHour = currentTime.wHour - 12;
	HICON hFinalIcon = CreateClockIcon(nTempHour,currentTime.wMinute,currentTime.wSecond,currentTime.wMilliseconds);
	MakeIcon(hFinalIcon,&currentTime);
	DestroyIcon(hFinalIcon);
}// end Timer
void MakeIcon(HICON hClockIcon,SYSTEMTIME *stCurrentTime)
{// begin MakeIcon
	if(hClockIcon != NULL)
	{// begin icon created successfully
		char pTip[50] = {NULL};
		TrayIcon(/*NIM_MODIFY*/NIM_ADD,hClockIcon,CreateTimeString(pTip,*stCurrentTime));
		TrayIcon(NIM_MODIFY,hClockIcon,CreateTimeString(pTip,*stCurrentTime));
	}// end icon created successfully
}// end MakeIcon
HICON CreateClockIcon(unsigned short nHour,unsigned short nMinute, unsigned short nSecond, unsigned short nMillisecond)
{// begin CreateClockIcon
	ICONINFO newIcon;
	newIcon.fIcon = true;	// set that it is an icon

	// create DC's
	HDC screenDC = ::GetDC(NULL);
	HDC iconDC = CreateCompatibleDC(screenDC);
	HDC maskDC = CreateCompatibleDC(screenDC);

	if(screenDC == NULL)
	{// begin error check
		return NULL;
	}// end error check
	if(iconDC == NULL)
	{// begin error check
		return NULL;
	}// end error check
	if(maskDC == NULL)
	{// begin error check
		return NULL;
	}// end error check
	
	// load bitmaps
	newIcon.hbmColor = CreateCompatibleBitmap(screenDC,16,16);
	if(newIcon.hbmColor == NULL)
	{// begin error check
		return NULL;
	}// end error check
	if(!::ReleaseDC(NULL,screenDC))	// release this ASAP
	{// begin DC not released
		return NULL;
	}// end DC not released
	newIcon.hbmMask = CreateCompatibleBitmap(maskDC,16,16);
	if(newIcon.hbmMask == NULL)
	{// begin error check
		return NULL;
	}// end error check
	HGDIOBJ oldIconDC = ::SelectObject(iconDC,newIcon.hbmColor);
	if(oldIconDC == NULL)
	{// begin error check
		return NULL;
	}// end error check
	HGDIOBJ oldMaskDC = ::SelectObject(maskDC,newIcon.hbmMask);
	if(oldMaskDC == NULL)
	{// begin error check
		return NULL;
	}// end error check

	// initilize the bitmaps
	if(!BitBlt(iconDC,0,0,16,16,NULL,0,0,BLACKNESS))
	{// begin BitBlt failed
		return NULL;
	}// end BitBlt failed
	if(!BitBlt(maskDC,0,0,16,16,NULL,0,0,WHITENESS))
	{// begin BitBlt failed
		return NULL;
	}// end BitBlt failed

	// draw the clock face
	if(!DrawIconEx(iconDC,0,0,hFrame,16,16,NULL,NULL,DI_NORMAL|DI_IMAGE))
	{// begin error check
		return NULL;
	}// end error check
	if(!DrawIconEx(maskDC,0,0,hFrame,16,16,NULL,NULL,DI_NORMAL|DI_MASK))
	{// begin error check
		return NULL;
	}// end error check

	// set center point
	POINT ptCenterPoint = {7,7};
	// draw the hands
	DrawIconHand(iconDC,maskDC,(nHour*5)+(nMinute/12),ptCenterPoint,60,6,RGB(0,0,0));
	DrawIconHand(iconDC,maskDC,nMinute,ptCenterPoint,60,8,RGB(0,0,0));
	DrawIconHand(iconDC,maskDC,nSecond,ptCenterPoint,60,8,RGB(200,0,0));
	if(bShowMilliseconds)
		DrawIconHand(iconDC,maskDC,nMillisecond,ptCenterPoint,1000,8,RGB(0,0,200));

	// create icon
	::SelectObject(iconDC,oldIconDC);
	::SelectObject(maskDC,oldMaskDC);
	HICON newFileIcon = CreateIconIndirect(&newIcon);

	// cleanup
	DeleteObject(newIcon.hbmColor);
	DeleteObject(newIcon.hbmMask);
	DeleteDC(maskDC);
	DeleteDC(iconDC);
	return newFileIcon;

}// end CreateClockIcon

bool DrawIconHand(HDC destDC,HDC destDCMask,int nValue,POINT ptCenterPoint,int nTotal,int nLength,COLORREF crColor)
{// begin DrawIconHand
	// draw hand
	int nWidth = 1;
	HPEN hPen = CreatePen(PS_SOLID,nWidth,crColor);
	POINT ptOldPoint = {NULL};
	POINT ptEndPoint = CalculateClockHandPos(ptCenterPoint,nValue,nTotal,nLength);
	if(hPen == NULL)
	{// begin error check
		return false;
	}// end error check
	HGDIOBJ hOldPen = SelectObject(destDC,hPen);
	if(hOldPen == NULL)
	{// begin error check
		return false;
	}// end error check
	MoveToEx(destDC,ptCenterPoint.x,ptCenterPoint.y,&ptOldPoint);
	if(!LineTo(destDC,ptEndPoint.x,ptEndPoint.y))
	{// begin error check
		return false;
	}// end error check
	if(!DeleteObject(SelectObject(destDC,hOldPen)))
	{// begin error check
		return false;
	}// end error check

	// draw hand mask
	HPEN hDestDCMaskPen = CreatePen(PS_SOLID,nWidth,RGB(0,0,0));
	if(hDestDCMaskPen == NULL)
	{// begin error check
		return false;
	}// end error check
	HGDIOBJ hOldDestDCMaskPen = SelectObject(destDCMask,hDestDCMaskPen);
	if(hOldDestDCMaskPen == NULL)
	{// begin error check
		return false;
	}// end error check
	MoveToEx(destDCMask,ptCenterPoint.x,ptCenterPoint.y,&ptOldPoint);
	if(!LineTo(destDCMask,ptEndPoint.x,ptEndPoint.y))
	{// begin error check
		return false;
	}// end error check
	if(!DeleteObject(SelectObject(destDCMask,hOldDestDCMaskPen)))
	{// begin error check
		return false;
	}// end error check

	return true;
}// end DrawIconHand

const char * GetCommandLineString(const char *pSourceString,char *pTempBuffer)
{// begin GetCommandLineString
	// advance to the beginning of the string
	for(;*pSourceString != '\0' && *pSourceString != ' ';pSourceString++);
	// advance to the next character
	pSourceString++;
	// get the length of the string
	for(int i = 0;pSourceString[i] != '\0' && pSourceString[i] != '"';i++);
	// advance to next character
	i++;
	// copy the string into the buffer
	lstrcpyn(pTempBuffer,pSourceString,i);
	// return the position after the string
	return &pSourceString[i];
}// end GetCommandLineString