// prototypes
char GetAlphaNum(const int &num);
int Pow(const int &num,const int &power);
int Atoi(const char *str);
const char *Itoa(int num,char *buffer);

void __cdecl WinMainCRTStartup( void )
{

    int mainret;
    char *lpszCommandLine;
    STARTUPINFO StartupInfo;

    lpszCommandLine = GetCommandLine();

    // Skip past program name (first token in command line).

    if ( *lpszCommandLine == '"' )  //Check for and handle quoted program name
    {
        // Scan, and skip over, subsequent characters until  another
        // double-quote or a null is encountered

        while( *lpszCommandLine && (*lpszCommandLine != '"') )
            lpszCommandLine++;

        // If we stopped on a double-quote (usual case), skip over it.

        if ( *lpszCommandLine == '"' )
            lpszCommandLine++;
    }
    else    // First token wasn't a quote
    {
        while ( *lpszCommandLine > ' ' )
            lpszCommandLine++;
    }

    // Skip past any white space preceeding the second token.

    while ( *lpszCommandLine && (*lpszCommandLine <= ' ') )
        lpszCommandLine++;

    StartupInfo.dwFlags = 0;
    GetStartupInfo( &StartupInfo );

    mainret = WinMain( GetModuleHandle(NULL),
                       NULL,
                       lpszCommandLine,
                       StartupInfo.dwFlags & STARTF_USESHOWWINDOW
                            ? StartupInfo.wShowWindow : SW_SHOWDEFAULT );

    ExitProcess(mainret);
}


char GetAlphaNum(const int &num)
{
//	ASSERT((num < 10) && (num > -1));
	char ch;
	switch(num)
	{
		case 0:
			ch = '0';
			break;
		case 1:
			ch = '1';
			break;
		case 2:
			ch = '2';
			break;
		case 3:
			ch = '3';
			break;
		case 4:
			ch = '4';
			break;
		case 5:
			ch = '5';
			break;
		case 6:
			ch = '6';
			break;
		case 7:
			ch = '7';
			break;
		case 8:
			ch = '8';
			break;
		case 9:
			ch = '9';
	}
	return ch;
}
int Pow(const int &num,const int &power)
{
	int tempNum = num;
	int tempPower = power;
	if(power == 0)
		return 1;
	for(;tempPower > 1;tempPower--)
	{
		tempNum *= num;
	}
	return tempNum;
}

int Atoi(const char *str)
{
	int num = 0;
	int strLength;
	strLength = lstrlen(str);
	for(int i = 0;i < strLength;i++)
	{
		switch(str[strLength-1-i])
		{
		case '0':
			continue;
		case '1':
			num += Pow(10,i);
			break;
		case '2':
			num += Pow(10,i)*2;
			break;
		case '3':
			num += Pow(10,i)*3;
			break;
		case '4':
			num += Pow(10,i)*4;
			break;
		case '5':
			num += Pow(10,i)*5;
			break;
		case '6':
			num += Pow(10,i)*6;
			break;
		case '7':
			num += Pow(10,i)*7;
			break;
		case '8':
			num += Pow(10,i)*8;
			break;
		case '9':
			num += Pow(10,i)*9;
			break;
		}
	}
	return num;
}
const char *Itoa(int num, char *buffer)
{
	int tempNum = num;
	char ch[1];
	for(int i = 1;1;i++)
	{
		ch[0] = GetAlphaNum(num%10);
		ch[1] = NULL;
		if(i == 1)
		{
			buffer[0] = ch[0];
			buffer[1] = NULL;
			num /= 10;
			continue;
		}
		lstrcat(buffer,ch);
		if((tempNum%Pow(10,i)) == tempNum)
		{// begin flip string
			char temp;
			int strLength = lstrlen(buffer);
			for(int i = 0;1;i++,strLength--)
			{// begin swap
				if(i >= strLength)
					return buffer;
				temp = buffer[strLength-1];
				buffer[strLength-1] = buffer[i];
				buffer[i] = temp;
			}// end swap
			
		}// end flip string
		num /= 10;
	}
}